﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;


namespace ASPNETAJAX
{
    public partial class WebForm4 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
                AddColumnsToGrid();
            BindData();
            if (!Page.IsPostBack)
            {
                //SetPaging();
            }
        }


        private DataTable GenerateData()
        {
            DataTable dt = new DataTable("ABC");

            dt.Columns.Add(new DataColumn("A1", Type.GetType("System.String")));
            dt.Columns.Add(new DataColumn("A2", Type.GetType("System.Int32")));

            for (int iCounter = 1; iCounter < 530; iCounter++)
            {
                DataRow dr;

                dr = dt.NewRow();
                dr["A1"] = "<a href='www.google.co.in'> Y" + iCounter.ToString("00") + "</a>";
                dr["A2"] = iCounter;
                dt.Rows.Add(dr);
            }

            Session["ABC"] = dt;
            return dt;
        }

        private void BindData()
        {
            DataTable dt = GetData();
            WebDataGrid1.AutoGenerateColumns = false;
            WebDataGrid1.DataSource = dt;
            WebDataGrid1.DataBind();   
        }

        protected void WebDataGrid1_PageIndexChanged(object sender, Infragistics.Web.UI.GridControls.PagingEventArgs e)
        {
            BindData();
        }

        private void SetPaging()
        {
            //DataTable dt = GetData();
            //dt.Rows.Count / 
            int PageCount = WebDataGrid1.Behaviors.Paging.PageCount;
            DropDownList list1 = (DropDownList) WebDataGrid1.Behaviors.Paging.PagerTemplateContainerBottom.FindControl("drpPage");
            for (int i = 1; i <= PageCount; i++)
            {
                list1.Items.Add(i.ToString());
            }
        }

        private DataTable GetData()
        {
            DataTable dt;
            if (Session["ABC"] != null)
                dt = (DataTable)Session["ABC"];
            else
                dt = GenerateData();

            return dt;
        }

        private void AddColumn(string columnKey, string baseColumn, string dataType)
        {
            BoundDataField column = new BoundDataField();

            column.Key = "Key_" + columnKey;
            column.DataFieldName = baseColumn;
            column.HtmlEncode = false;
            column.DataType = dataType;
            column.Header.Text = columnKey;
            WebDataGrid1.Columns.Add(column);
        }

        private void AddCheckBoxColumn(string columnKey, string dataType)
        {
            UnboundCheckBoxField column = new UnboundCheckBoxField();

            column.Key = columnKey;
            column.HtmlEncode = false;
            column.DataType = dataType;

            column.HeaderCheckBoxMode = Infragistics.Web.UI.CheckBoxMode.TriState;

            column.Header.Text = columnKey;
            WebDataGrid1.Columns.Add(column);
        }

        private void AddColumnsToGrid()
        {
            AddCheckBoxColumn("Select", "System.Boolean");
            AddColumn("A1", "A1", "System.String");
            AddColumn("A2", "A2", "System.Int64");
        }

        protected void Export2Excel_Click(object sender, EventArgs e)
        {
            this.excelExporter.DownloadName = "Test";
            this.excelExporter.WorkbookFormat = Infragistics.Documents.Excel.WorkbookFormat.Excel2007;
            this.excelExporter.DataExportMode = DataExportMode.AllDataInDataSource;
            //this.excelExporter.CellExporting += new ExcelCellExportingEventHandler(excelExporter_CellExporting);
            this.excelExporter.GridRecordItemExporting += new GridRecordItemExportingEventHandler(excelExporter_GridRecordItemExporting);
            this.excelExporter.Export(this.WebDataGrid1);
        }

        void excelExporter_GridRecordItemExporting(object sender, GridRecordItemExportingEventArgs e)
        {
            e.WorksheetCell.Value = System.Text.RegularExpressions.Regex.Replace(e.GridCell.Value.ToString(), "<a[^>]+>([^<]+)</a>", "$1");
            e.Cancel = true;
        }

        protected void Export2PDF_Click(object sender, EventArgs e)
        {
            this.documentExporter.Format = FileFormat.PDF;
            this.documentExporter.DownloadName = "Test";
            this.documentExporter.DataExportMode = DataExportMode.AllDataInDataSource;
            this.documentExporter.CellExporting += new EventHandler<DocumentCellExportingEventArgs>(documentExporter_CellExporting);
            this.documentExporter.Export(this.WebDataGrid1);
        }

        void documentExporter_CellExporting(object sender, DocumentCellExportingEventArgs e)
        {
            if (e.GridCell != null)
                e.ExportValue = System.Text.RegularExpressions.Regex.Replace(e.GridCell.Value.ToString(), "<a[^>]+>([^<]+)</a>", "$1");
        }
    }
}